<script lang="ts" setup>
import { storeToRefs } from 'pinia'
import ProgressSpinner from 'primevue/progressspinner'
import UserMenu from '@/components/UserMenu.vue'
import LicensesTable from '@/components/LicensesTable.vue'
import ProductsTable from '@/components/ProductsTable.vue'
import { useLicenseeStore } from '@/stores/licensee'
import { useLoadingStore } from '@/stores/loading'
import { useUserStore } from '@/stores/user'

const licenseeStore = useLicenseeStore()
await licenseeStore.loadLicensees()
const { selectedLicenseeId } = storeToRefs(licenseeStore)
const userStore = useUserStore()
const { displayName } = storeToRefs(userStore)
const loadingStore = useLoadingStore()

const { isLoading } = storeToRefs(loadingStore)

</script>

<template>
  <div class="dashboard">
    <UserMenu />
    <div class="content pt-5 flex justify-center">
      <div class="w-full xl:w-10/12">
        <h1 class="text-3xl pb-3">Welcome {{ displayName }}</h1>
        <h2>Displaying information for licensee: {{ licenseeStore.selected!.name }} ({{ licenseeStore.selected!.isPerson ? "Person" : "Company" }})</h2>
        <ProductsTable :key="selectedLicenseeId" class="pt-5" />
        <LicensesTable :key="selectedLicenseeId" class="pt-5" />
      </div>
    </div>
    <div class="absolute inset-0 flex justify-center items-center z-10 bg-opacity-25 bg-gray-200" v-if="isLoading">
      <div class="m-auto">
        <ProgressSpinner data-test="spinner" v-if="isLoading" aria-label="Loading" />
      </div>
    </div>
  </div>
</template>
